Package com.microsoft.sqlserver.jdbc

## Class SQLServerResultSet

- java.lang.Object
- - com.microsoft.sqlserver.jdbc.SQLServerResultSet

All Implemented Interfaces:
  `ISQLServerResultSet`, `AutoCloseable`, `ResultSet`, `Wrapper`

Direct Known Subclasses:
  `SQLServerResultSet42`

    public class SQLServerResultSet
    extends Object
    implements ISQLServerResultSet

Top-level JDBC ResultSet implementation

### Field Summary

Fields
`protected static Logger` `loggerExternal`

### Fields inherited from interface com.microsoft.sqlserver.jdbc.ISQLServerResultSet

`CONCUR_SS_OPTIMISTIC_CC, CONCUR_SS_OPTIMISTIC_CCVAL, CONCUR_SS_SCROLL_LOCKS, TYPE_SS_DIRECT_FORWARD_ONLY, TYPE_SS_SCROLL_DYNAMIC, TYPE_SS_SCROLL_KEYSET, TYPE_SS_SCROLL_STATIC, TYPE_SS_SERVER_CURSOR_FORWARD_ONLY`

### Fields inherited from interface java.sql.ResultSet

`CLOSE_CURSORS_AT_COMMIT, CONCUR_READ_ONLY, CONCUR_UPDATABLE, FETCH_FORWARD, FETCH_REVERSE, FETCH_UNKNOWN, HOLD_CURSORS_OVER_COMMIT, TYPE_FORWARD_ONLY, TYPE_SCROLL_INSENSITIVE, TYPE_SCROLL_SENSITIVE`

### Method Summary

All Methods Instance Methods Concrete Methods Deprecated Methods
`boolean` `absolute​(int row)` Moves the cursor to the specified row in this ResultSet object.
`void` `afterLast​()`
`void` `beforeFirst​()`
`void` `cancelRowUpdates​()`
`void` `clearWarnings​()` Clear result set warnings
`void` `close​()`
`void` `deleteRow​()`
`int` `findColumn​(String columnName)` Find a column index given a column name
`boolean` `first​()` Moves the cursor to the first row in this ResultSet object.
`Array` `getArray​(int i)`
`Array` `getArray​(String colName)`
`InputStream` `getAsciiStream​(int columnIndex)`
`InputStream` `getAsciiStream​(String columnName)`
`BigDecimal` `getBigDecimal​(int columnIndex)`
`BigDecimal` `getBigDecimal​(int columnIndex, int scale)` Deprecated.
`BigDecimal` `getBigDecimal​(String columnName)`
`BigDecimal` `getBigDecimal​(String columnName, int scale)` Deprecated.
`InputStream` `getBinaryStream​(int columnIndex)`
`InputStream` `getBinaryStream​(String columnName)`
`Blob` `getBlob​(int i)`
`Blob` `getBlob​(String colName)`
`boolean` `getBoolean​(int columnIndex)`
`boolean` `getBoolean​(String columnName)`
`byte` `getByte​(int columnIndex)`
`byte` `getByte​(String columnName)`
`byte[]` `getBytes​(int columnIndex)`
`byte[]` `getBytes​(String columnName)`
`Reader` `getCharacterStream​(int columnIndex)`
`Reader` `getCharacterStream​(String columnName)`
`Clob` `getClob​(int columnIndex)`
`Clob` `getClob​(String colName)`
`int` `getConcurrency​()`
`String` `getCursorName​()`
`Date` `getDate​(int columnIndex)`
`Date` `getDate​(int columnIndex, Calendar cal)`
`Date` `getDate​(String columnName)`
`Date` `getDate​(String colName, Calendar cal)`
`Timestamp` `getDateTime​(int columnIndex)` Retrieves the value of the designated column in the current row of this ResultSet object as a java.sql.Timestamp object in the Java programming language.
`Timestamp` `getDateTime​(int columnIndex, Calendar cal)` Retrieves the value of the designated column in the current row of this ResultSet object as a java.sql.Timestamp object in the Java programming language.
`Timestamp` `getDateTime​(String columnName)` Retrieves the value of the designated column in the current row of this ResultSet object as a java.sql.Timestamp object in the Java programming language.
`Timestamp` `getDateTime​(String colName, Calendar cal)` Retrieves the value of the designated column in the current row of this ResultSet object as a java.sql.Timestamp object in the Java programming language.
`DateTimeOffset` `getDateTimeOffset​(int columnIndex)` Retrieves the value of the designated column as a microsoft.sql.DateTimeOffset object, given a zero-based column ordinal.
`DateTimeOffset` `getDateTimeOffset​(String columnName)` Retrieves the value of the column specified as a microsoft.sql.DateTimeOffset object, given a column name.
`double` `getDouble​(int columnIndex)`
`double` `getDouble​(String columnName)`
`int` `getFetchDirection​()`
`int` `getFetchSize​()`
`float` `getFloat​(int columnIndex)`
`float` `getFloat​(String columnName)`
`int` `getHoldability​()`
`int` `getInt​(int columnIndex)`
`int` `getInt​(String columnName)`
`long` `getLong​(int columnIndex)`
`long` `getLong​(String columnName)`
`ResultSetMetaData` `getMetaData​()`
`BigDecimal` `getMoney​(int columnIndex)` Retrieves the value of the column specified as a java.math.BigDecimal object.
`BigDecimal` `getMoney​(String columnName)` Retrieves the value of the column specified as a java.math.BigDecimal object.
`Reader` `getNCharacterStream​(int columnIndex)`
`Reader` `getNCharacterStream​(String columnLabel)`
`NClob` `getNClob​(int columnIndex)`
`NClob` `getNClob​(String columnLabel)`
`String` `getNString​(int columnIndex)`
`String` `getNString​(String columnLabel)`
`Object` `getObject​(int columnIndex)`
`<T> T` `getObject​(int columnIndex, Class<T> type)`
`Object` `getObject​(int i, Map<String,Class<?>> map)`
`Object` `getObject​(String columnName)`
`<T> T` `getObject​(String columnName, Class<T> type)`
`Object` `getObject​(String colName, Map<String,Class<?>> map)`
`Ref` `getRef​(int i)`
`Ref` `getRef​(String colName)`
`int` `getRow​()` Retrieves the number of the current row in this ResultSet object.
`RowId` `getRowId​(int columnIndex)`
`RowId` `getRowId​(String columnLabel)`
`protected int` `getServerCursorId​()`
`short` `getShort​(int columnIndex)`
`short` `getShort​(String columnName)`
`Timestamp` `getSmallDateTime​(int columnIndex)` Retrieves the value of the designated column in the current row of this ResultSet object as a java.sql.Timestamp object in the Java programming language.
`Timestamp` `getSmallDateTime​(int columnIndex, Calendar cal)` Retrieves the value of the designated column in the current row of this ResultSet object as a java.sql.Timestamp object in the Java programming language.
`Timestamp` `getSmallDateTime​(String columnName)` Retrieves the value of the designated column in the current row of this ResultSet object as a java.sql.Timestamp object in the Java programming language.
`Timestamp` `getSmallDateTime​(String colName, Calendar cal)`
`BigDecimal` `getSmallMoney​(int columnIndex)` Retrieves the value of the column specified as a java.math.BigDecimal object.
`BigDecimal` `getSmallMoney​(String columnName)` Retrieves the value of the column specified as a java.math.BigDecimal object.
`SQLXML` `getSQLXML​(int columnIndex)`
`SQLXML` `getSQLXML​(String columnLabel)`
`Statement` `getStatement​()`
`String` `getString​(int columnIndex)`
`String` `getString​(String columnName)`
`protected com.microsoft.sqlserver.jdbc.TDSReader` `getTDSReader​()`
`Time` `getTime​(int columnIndex)`
`Time` `getTime​(int columnIndex, Calendar cal)`
`Time` `getTime​(String columnName)`
`Time` `getTime​(String colName, Calendar cal)`
`Timestamp` `getTimestamp​(int columnIndex)`
`Timestamp` `getTimestamp​(int columnIndex, Calendar cal)`
`Timestamp` `getTimestamp​(String columnName)`
`Timestamp` `getTimestamp​(String colName, Calendar cal)`
`int` `getType​()`
`InputStream` `getUnicodeStream​(int columnIndex)` Deprecated.
`InputStream` `getUnicodeStream​(String columnName)` Deprecated.
`String` `getUniqueIdentifier​(int columnIndex)` Retrieves the value of the designated column in the current row of this ResultSet object as a microsoft.sql.datetimeoffset object in the Java programming language.
`String` `getUniqueIdentifier​(String columnLabel)` Retrieves the value of the designated column in the current row of this ResultSet object as a microsoft.sql.datetimeoffset object in the Java programming language.
`URL` `getURL​(int columnIndex)`
`URL` `getURL​(String sColumn)`
`SQLWarning` `getWarnings​()`
`void` `insertRow​()`
`boolean` `isAfterLast​()`
`boolean` `isBeforeFirst​()`
`boolean` `isClosed​()`
`boolean` `isFirst​()` Determines whether the cursor is on the first row in this ResultSet object.
`protected boolean` `isForwardOnly​()`
`boolean` `isLast​()` Determines whether the cursor is on the last row in this ResultSet object.
`boolean` `isWrapperFor​(Class<?> iface)`
`boolean` `last​()` Moves the cursor to the last row in this ResultSet object.
`void` `moveToCurrentRow​()`
`void` `moveToInsertRow​()`
`boolean` `next​()` Initially moves the cursor to the first row of this ResultSet object, with subsequent calls moving the cursor to the second row, the third row, and so on.
`boolean` `previous​()` Moves the cursor to the previous row in this ResultSet object.
`void` `refreshRow​()`
`boolean` `relative​(int rows)`
`boolean` `rowDeleted​()`
`boolean` `rowInserted​()`
`boolean` `rowUpdated​()`
`void` `setFetchDirection​(int direction)`
`void` `setFetchSize​(int rows)`
`String` `toString​()`
`<T> T` `unwrap​(Class<T> iface)`
`void` `updateArray​(int columnIndex, Array x)`
`void` `updateArray​(String columnName, Array x)`
`void` `updateAsciiStream​(int columnIndex, InputStream x)`
`void` `updateAsciiStream​(int index, InputStream x, int length)`
`void` `updateAsciiStream​(int columnIndex, InputStream x, long length)`
`void` `updateAsciiStream​(String columnLabel, InputStream x)`
`void` `updateAsciiStream​(String columnName, InputStream x, int length)`
`void` `updateAsciiStream​(String columnName, InputStream streamValue, long length)`
`void` `updateBigDecimal​(int index, BigDecimal x)`
`void` `updateBigDecimal​(int index, BigDecimal x, Integer precision, Integer scale)` Updates the designated column with a `java.math.BigDecimal` value.
`void` `updateBigDecimal​(int index, BigDecimal x, Integer precision, Integer scale, boolean forceEncrypt)` Updates the designated column with a `java.math.BigDecimal` value.
`void` `updateBigDecimal​(String columnName, BigDecimal x)`
`void` `updateBigDecimal​(String columnName, BigDecimal x, boolean forceEncrypt)` Updates the designated column with a `java.sql.BigDecimal` value.
`void` `updateBigDecimal​(String columnName, BigDecimal x, Integer precision, Integer scale)` Updates the designated column with a `java.sql.BigDecimal` value.
`void` `updateBigDecimal​(String columnName, BigDecimal x, Integer precision, Integer scale, boolean forceEncrypt)` Updates the designated column with a `java.sql.BigDecimal` value.
`void` `updateBinaryStream​(int columnIndex, InputStream x)`
`void` `updateBinaryStream​(int columnIndex, InputStream streamValue, int length)`
`void` `updateBinaryStream​(int columnIndex, InputStream x, long length)`
`void` `updateBinaryStream​(String columnLabel, InputStream x)`
`void` `updateBinaryStream​(String columnName, InputStream streamValue, int length)`
`void` `updateBinaryStream​(String columnLabel, InputStream x, long length)`
`void` `updateBlob​(int columnIndex, InputStream inputStream)`
`void` `updateBlob​(int columnIndex, InputStream inputStream, long length)`
`void` `updateBlob​(int columnIndex, Blob blobValue)`
`void` `updateBlob​(String columnLabel, InputStream inputStream)`
`void` `updateBlob​(String columnLabel, InputStream inputStream, long length)`
`void` `updateBlob​(String columnName, Blob blobValue)`
`void` `updateBoolean​(int index, boolean x)`
`void` `updateBoolean​(int index, boolean x, boolean forceEncrypt)` Updates the designated column with a `boolean` value.
`void` `updateBoolean​(String columnName, boolean x)`
`void` `updateBoolean​(String columnName, boolean x, boolean forceEncrypt)` Updates the designated column with a `boolean` value.
`void` `updateByte​(int index, byte x)`
`void` `updateByte​(int index, byte x, boolean forceEncrypt)` Updates the designated column with a `byte` value.
`void` `updateByte​(String columnName, byte x)`
`void` `updateByte​(String columnName, byte x, boolean forceEncrypt)` Updates the designated column with a `byte` value.
`void` `updateBytes​(int index, byte[] x)`
`void` `updateBytes​(int index, byte[] x, boolean forceEncrypt)` Updates the designated column with a `byte` array value.
`void` `updateBytes​(String columnName, byte[] x)`
`void` `updateBytes​(String columnName, byte[] x, boolean forceEncrypt)` Updates the designated column with a byte array value.
`void` `updateCharacterStream​(int columnIndex, Reader x)`
`void` `updateCharacterStream​(int columnIndex, Reader readerValue, int length)`
`void` `updateCharacterStream​(int columnIndex, Reader x, long length)`
`void` `updateCharacterStream​(String columnLabel, Reader reader)`
`void` `updateCharacterStream​(String columnName, Reader readerValue, int length)`
`void` `updateCharacterStream​(String columnLabel, Reader reader, long length)`
`void` `updateClob​(int columnIndex, Reader reader)`
`void` `updateClob​(int columnIndex, Reader reader, long length)`
`void` `updateClob​(int columnIndex, Clob clobValue)`
`void` `updateClob​(String columnLabel, Reader reader)`
`void` `updateClob​(String columnLabel, Reader reader, long length)`
`void` `updateClob​(String columnName, Clob clobValue)`
`void` `updateDate​(int index, Date x)`
`void` `updateDate​(int index, Date x, boolean forceEncrypt)` Updates the designated column with a `java.sql.Date` value.
`void` `updateDate​(String columnName, Date x)`
`void` `updateDate​(String columnName, Date x, boolean forceEncrypt)` Updates the designated column with a `java.sql.Date` value.
`void` `updateDateTime​(int index, Timestamp x)` Updates the designated column with a `java.sql.Timestamp` value.
`void` `updateDateTime​(int index, Timestamp x, Integer scale)` Updates the designated column with a `java.sql.Timestamp` value.
`void` `updateDateTime​(int index, Timestamp x, Integer scale, boolean forceEncrypt)` Updates the designated column with a `java.sql.Timestamp` value.
`void` `updateDateTime​(String columnName, Timestamp x)` Updates the designated column with a `java.sql.Timestamp` value.
`void` `updateDateTime​(String columnName, Timestamp x, int scale)` Updates the designated column with a `java.sql.Timestamp` value.
`void` `updateDateTime​(String columnName, Timestamp x, int scale, boolean forceEncrypt)` Updates the designated column with a `java.sql.Timestamp` value.
`void` `updateDateTimeOffset​(int index, DateTimeOffset x)` Updates the value of the column specified to the DateTimeOffset Class value, given a zero-based column ordinal.
`void` `updateDateTimeOffset​(int index, DateTimeOffset x, Integer scale)` Updates the value of the column specified to the DateTimeOffset Class value, given a zero-based column ordinal.
`void` `updateDateTimeOffset​(int index, DateTimeOffset x, Integer scale, boolean forceEncrypt)` Updates the value of the column specified to the DateTimeOffset Class value, given a zero-based column ordinal.
`void` `updateDateTimeOffset​(String columnName, DateTimeOffset x)` Updates the value of the column specified to the DateTimeOffset Class value, given a column name.
`void` `updateDateTimeOffset​(String columnName, DateTimeOffset x, int scale)` Updates the value of the column specified to the DateTimeOffset Class value, given a column name.
`void` `updateDateTimeOffset​(String columnName, DateTimeOffset x, int scale, boolean forceEncrypt)` Updates the value of the column specified to the DateTimeOffset Class value, given a column name.
`void` `updateDouble​(int index, double x)`
`void` `updateDouble​(int index, double x, boolean forceEncrypt)` Updates the designated column with a `double` value.
`void` `updateDouble​(String columnName, double x)`
`void` `updateDouble​(String columnName, double x, boolean forceEncrypt)` Updates the designated column with a `double` value.
`void` `updateFloat​(int index, float x)`
`void` `updateFloat​(int index, float x, boolean forceEncrypt)` Updates the designated column with a `float` value.
`void` `updateFloat​(String columnName, float x)`
`void` `updateFloat​(String columnName, float x, boolean forceEncrypt)` Updates the designated column with a `float` value.
`void` `updateInt​(int index, int x)`
`void` `updateInt​(int index, int x, boolean forceEncrypt)` Updates the designated column with an `int` value.
`void` `updateInt​(String columnName, int x)`
`void` `updateInt​(String columnName, int x, boolean forceEncrypt)` Updates the designated column with an `int` value.
`void` `updateLong​(int index, long x)`
`void` `updateLong​(int index, long x, boolean forceEncrypt)` Updates the designated column with a `long` value.
`void` `updateLong​(String columnName, long x)`
`void` `updateLong​(String columnName, long x, boolean forceEncrypt)` Updates the designated column with a `long` value.
`void` `updateMoney​(int index, BigDecimal x)` Updates the designated column with a `money` value.
`void` `updateMoney​(int index, BigDecimal x, boolean forceEncrypt)` Updates the designated column with a `money` value.
`void` `updateMoney​(String columnName, BigDecimal x)` Updates the designated column with a `money` value.
`void` `updateMoney​(String columnName, BigDecimal x, boolean forceEncrypt)` Updates the designated column with a `money` value.
`void` `updateNCharacterStream​(int columnIndex, Reader x)`
`void` `updateNCharacterStream​(int columnIndex, Reader x, long length)`
`void` `updateNCharacterStream​(String columnLabel, Reader reader)`
`void` `updateNCharacterStream​(String columnLabel, Reader reader, long length)`
`void` `updateNClob​(int columnIndex, Reader reader)`
`void` `updateNClob​(int columnIndex, Reader reader, long length)`
`void` `updateNClob​(int columnIndex, NClob nClob)`
`void` `updateNClob​(String columnLabel, Reader reader)`
`void` `updateNClob​(String columnLabel, Reader reader, long length)`
`void` `updateNClob​(String columnLabel, NClob nClob)`
`void` `updateNString​(int columnIndex, String nString)`
`void` `updateNString​(int columnIndex, String nString, boolean forceEncrypt)` Updates the designated column with a `String` value.
`void` `updateNString​(String columnLabel, String nString)`
`void` `updateNString​(String columnLabel, String nString, boolean forceEncrypt)` Updates the designated column with a `String` value.
`void` `updateNull​(int index)`
`void` `updateNull​(String columnName)`
`void` `updateObject​(int index, Object obj)`
`void` `updateObject​(int index, Object x, int scale)`
`void` `updateObject​(int index, Object x, int precision, int scale)` Updates the designated column with an `Object` value.
`void` `updateObject​(int index, Object x, int precision, int scale, boolean forceEncrypt)` Updates the designated column with an `Object` value.
`protected void` `updateObject​(int index, Object x, Integer scale, com.microsoft.sqlserver.jdbc.JDBCType jdbcType, Integer precision, boolean forceEncrypt)`
`void` `updateObject​(String columnName, Object x)`
`void` `updateObject​(String columnName, Object x, int scale)`
`void` `updateObject​(String columnName, Object x, int precision, int scale)` Updates the designated column with an `Object` value.
`void` `updateObject​(String columnName, Object x, int precision, int scale, boolean forceEncrypt)` Updates the designated column with an `Object` value.
`void` `updateRef​(int columnIndex, Ref x)`
`void` `updateRef​(String columnName, Ref x)`
`void` `updateRow​()`
`void` `updateRowId​(int columnIndex, RowId x)`
`void` `updateRowId​(String columnLabel, RowId x)`
`void` `updateShort​(int index, short x)`
`void` `updateShort​(int index, short x, boolean forceEncrypt)` Updates the designated column with a `short` value.
`void` `updateShort​(String columnName, short x)`
`void` `updateShort​(String columnName, short x, boolean forceEncrypt)` Updates the designated column with a `short` value.
`void` `updateSmallDateTime​(int index, Timestamp x)` Updates the designated column with a `java.sql.Timestamp` value.
`void` `updateSmallDateTime​(int index, Timestamp x, Integer scale)` Updates the designated column with a `java.sql.Timestamp` value.
`void` `updateSmallDateTime​(int index, Timestamp x, Integer scale, boolean forceEncrypt)` Updates the designated column with a `java.sql.Timestamp` value.
`void` `updateSmallDateTime​(String columnName, Timestamp x)` Updates the designated column with a `java.sql.Timestamp` value.
`void` `updateSmallDateTime​(String columnName, Timestamp x, int scale)` Updates the designated column with a `java.sql.Timestamp` value.
`void` `updateSmallDateTime​(String columnName, Timestamp x, int scale, boolean forceEncrypt)` Updates the designated column with a `java.sql.Timestamp` value.
`void` `updateSmallMoney​(int index, BigDecimal x)` Updates the designated column with a `smallmoney` value.
`void` `updateSmallMoney​(int index, BigDecimal x, boolean forceEncrypt)` Updates the designated column with a `smallmoney` value.
`void` `updateSmallMoney​(String columnName, BigDecimal x)` Updates the designated column with a `smallmoney` value.
`void` `updateSmallMoney​(String columnName, BigDecimal x, boolean forceEncrypt)` Updates the designated column with a `smallmoney` value.
`void` `updateSQLXML​(int columnIndex, SQLXML xmlObject)`
`void` `updateSQLXML​(String columnLabel, SQLXML x)`
`void` `updateString​(int columnIndex, String stringValue)`
`void` `updateString​(int columnIndex, String stringValue, boolean forceEncrypt)` Updates the designated column with a `String` value.
`void` `updateString​(String columnName, String x)`
`void` `updateString​(String columnName, String x, boolean forceEncrypt)` Updates the designated column with a `String` value.
`void` `updateTime​(int index, Time x)`
`void` `updateTime​(int index, Time x, Integer scale)` Updates the designated column with a `java.sql.Time` value.
`void` `updateTime​(int index, Time x, Integer scale, boolean forceEncrypt)` Updates the designated column with a `java.sql.Time` value.
`void` `updateTime​(String columnName, Time x)`
`void` `updateTime​(String columnName, Time x, int scale)` Updates the designated column with a `java.sql.Time` value.
`void` `updateTime​(String columnName, Time x, int scale, boolean forceEncrypt)` Updates the designated column with a `java.sql.Time` value.
`void` `updateTimestamp​(int index, Timestamp x)`
`void` `updateTimestamp​(int index, Timestamp x, int scale)` Updates the designated column with a `java.sql.Timestamp` value.
`void` `updateTimestamp​(int index, Timestamp x, int scale, boolean forceEncrypt)` Updates the designated column with a `java.sql.Timestamp` value.
`void` `updateTimestamp​(String columnName, Timestamp x)`
`void` `updateTimestamp​(String columnName, Timestamp x, int scale)` Updates the designated column with a `java.sql.Timestamp` value.
`void` `updateTimestamp​(String columnName, Timestamp x, int scale, boolean forceEncrypt)` Updates the designated column with a `java.sql.Timestamp` value.
`void` `updateUniqueIdentifier​(int index, String x)` Updates the designated column with a `String` value.
`void` `updateUniqueIdentifier​(int index, String x, boolean forceEncrypt)` Updates the designated column with a `String` value.
`void` `updateUniqueIdentifier​(String columnName, String x)` Updates the designated column with a `String`value.
`void` `updateUniqueIdentifier​(String columnName, String x, boolean forceEncrypt)` Updates the designated column with a `String`value.
`boolean` `wasNull​()`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.sql.ResultSet

`updateObject, updateObject, updateObject, updateObject`

### Field Detail

#### loggerExternal

    protected static final Logger loggerExternal

### Method Detail

#### toString

    public String toString​()

Overrides:
  `toString` in class `Object`

#### getServerCursorId

    protected int getServerCursorId​()

#### getTDSReader

    protected com.microsoft.sqlserver.jdbc.TDSReader getTDSReader​()

#### isWrapperFor

    public boolean isWrapperFor​(Class<?> iface)
                         throws SQLException

Specified by:
  `isWrapperFor` in interface `Wrapper`
Throws:
  `SQLException`

#### unwrap

    public <T> T unwrap​(Class<T> iface)
                 throws SQLException

Specified by:
  `unwrap` in interface `Wrapper`
Throws:
  `SQLException`

#### isClosed

    public boolean isClosed​()
                     throws SQLException

Specified by:
  `isClosed` in interface `ResultSet`
Throws:
  `SQLException`

#### isForwardOnly

    protected boolean isForwardOnly​()

#### close

    public void close​()
               throws SQLServerException

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `ResultSet`
Throws:
  `SQLServerException`

#### findColumn

    public int findColumn​(String columnName)
                   throws SQLServerException

Find a column index given a column name

Specified by:
  `findColumn` in interface `ResultSet`
Parameters:
  `columnName` - the name of the column
Returns:
  the column index
Throws:
  `SQLServerException` - If any errors occur.

#### clearWarnings

    public void clearWarnings​()
                       throws SQLServerException

Clear result set warnings

Specified by:
  `clearWarnings` in interface `ResultSet`
Throws:
  `SQLServerException` - when an error occurs

#### relative

    public boolean relative​(int rows)
                     throws SQLServerException

Specified by:
  `relative` in interface `ResultSet`
Throws:
  `SQLServerException`

#### next

    public boolean next​()
                 throws SQLServerException

Initially moves the cursor to the first row of this ResultSet object, with subsequent calls moving the cursor to the second row, the third row, and so on.

Specified by:
  `next` in interface `ResultSet`
Returns:
  false when there are no more rows to read
Throws:
  `SQLServerException`

#### wasNull

    public boolean wasNull​()
                    throws SQLServerException

Specified by:
  `wasNull` in interface `ResultSet`
Throws:
  `SQLServerException`

#### isBeforeFirst

    public boolean isBeforeFirst​()
                          throws SQLServerException

Specified by:
  `isBeforeFirst` in interface `ResultSet`
Returns:
  true if the cursor is before the first row in this result set, returns false otherwise or if the result set contains no rows.
Throws:
  `SQLServerException`

#### isAfterLast

    public boolean isAfterLast​()
                        throws SQLServerException

Specified by:
  `isAfterLast` in interface `ResultSet`
Throws:
  `SQLServerException`

#### isFirst

    public boolean isFirst​()
                    throws SQLServerException

Determines whether the cursor is on the first row in this ResultSet object. This method should be called only on ResultSet objects that are scrollable: TYPE_SCROLL_SENSITIVE, TYPE_SCROLL_INSENSITIVE, TYPE_SS_SCROLL_STATIC, TYPE_SS_SCROLL_KEYSET, TYPE_SS_SCROLL_DYNAMIC.

Specified by:
  `isFirst` in interface `ResultSet`
Returns:
  true if the cursor is on the first row in this result set
Throws:
  `SQLServerException`

#### isLast

    public boolean isLast​()
                   throws SQLServerException

Determines whether the cursor is on the last row in this ResultSet object. This method should be called only on ResultSet objects that are scrollable: TYPE_SCROLL_SENSITIVE, TYPE_SCROLL_INSENSITIVE, TYPE_SS_SCROLL_STATIC, TYPE_SS_SCROLL_KEYSET, TYPE_SS_SCROLL_DYNAMIC.

Specified by:
  `isLast` in interface `ResultSet`
Returns:
  true if the cursor is on the last row in this result set
Throws:
  `SQLServerException`

#### beforeFirst

    public void beforeFirst​()
                     throws SQLServerException

Specified by:
  `beforeFirst` in interface `ResultSet`
Throws:
  `SQLServerException`

#### afterLast

    public void afterLast​()
                   throws SQLServerException

Specified by:
  `afterLast` in interface `ResultSet`
Throws:
  `SQLServerException`

#### first

    public boolean first​()
                  throws SQLServerException

Moves the cursor to the first row in this ResultSet object. This method should be called only on ResultSet objects that are scrollable: TYPE_SCROLL_SENSITIVE, TYPE_SCROLL_INSENSITIVE, TYPE_SS_SCROLL_STATIC, TYPE_SS_SCROLL_KEYSET, TYPE_SS_SCROLL_DYNAMIC.

Specified by:
  `first` in interface `ResultSet`
Returns:
  true if the cursor is on a valid row, otherwise returns false if there are no rows in this ResultSet object
Throws:
  `SQLServerException`

#### last

    public boolean last​()
                 throws SQLServerException

Moves the cursor to the last row in this ResultSet object. This method should be called only on ResultSet objects that are scrollable: TYPE_SCROLL_SENSITIVE, TYPE_SCROLL_INSENSITIVE, TYPE_SS_SCROLL_STATIC, TYPE_SS_SCROLL_KEYSET, TYPE_SS_SCROLL_DYNAMIC.

Specified by:
  `last` in interface `ResultSet`
Returns:
  true if the cursor is on a valid row, otherwise returns false if there are no rows in this ResultSet object
Throws:
  `SQLServerException`

#### getRow

    public int getRow​()
               throws SQLServerException

Retrieves the number of the current row in this ResultSet object. The first row is number 1, the second is 2, and so on.

Specified by:
  `getRow` in interface `ResultSet`
Returns:
  the number of the current row; 0 if there is no current row
Throws:
  `SQLServerException`

#### absolute

    public boolean absolute​(int row)
                     throws SQLServerException

Moves the cursor to the specified row in this ResultSet object. The specified row may be positive, negative or zero. This method should be called only on ResultSet objects that are scrollable: TYPE_SCROLL_SENSITIVE, TYPE_SCROLL_INSENSITIVE, TYPE_SS_SCROLL_STATIC, TYPE_SS_SCROLL_KEYSET, TYPE_SS_SCROLL_DYNAMIC.

Specified by:
  `absolute` in interface `ResultSet`
Returns:
  true if the cursor is on a valid row in this result set, otherwise returns false if the cursor is before the first row or after the last row
Throws:
  `SQLServerException`

#### previous

    public boolean previous​()
                     throws SQLServerException

Moves the cursor to the previous row in this ResultSet object. This method should be called only on ResultSet objects that are scrollable: TYPE_SCROLL_SENSITIVE, TYPE_SCROLL_INSENSITIVE, TYPE_SS_SCROLL_STATIC, TYPE_SS_SCROLL_KEYSET, TYPE_SS_SCROLL_DYNAMIC.

Specified by:
  `previous` in interface `ResultSet`
Returns:
  true if the cursor is on a valid row in this result set
Throws:
  `SQLServerException`

#### getWarnings

    public SQLWarning getWarnings​()
                           throws SQLServerException

Specified by:
  `getWarnings` in interface `ResultSet`
Throws:
  `SQLServerException`

#### setFetchDirection

    public void setFetchDirection​(int direction)
                           throws SQLServerException

Specified by:
  `setFetchDirection` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getFetchDirection

    public int getFetchDirection​()
                          throws SQLServerException

Specified by:
  `getFetchDirection` in interface `ResultSet`
Throws:
  `SQLServerException`

#### setFetchSize

    public void setFetchSize​(int rows)
                      throws SQLServerException

Specified by:
  `setFetchSize` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getFetchSize

    public int getFetchSize​()
                     throws SQLServerException

Specified by:
  `getFetchSize` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getType

    public int getType​()
                throws SQLServerException

Specified by:
  `getType` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getConcurrency

    public int getConcurrency​()
                       throws SQLServerException

Specified by:
  `getConcurrency` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getAsciiStream

    public InputStream getAsciiStream​(int columnIndex)
                               throws SQLServerException

Specified by:
  `getAsciiStream` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getAsciiStream

    public InputStream getAsciiStream​(String columnName)
                               throws SQLServerException

Specified by:
  `getAsciiStream` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getBigDecimal

    @Deprecated
    public BigDecimal getBigDecimal​(int columnIndex,
                                    int scale)
                             throws SQLServerException

Deprecated.

Specified by:
  `getBigDecimal` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getBigDecimal

    @Deprecated
    public BigDecimal getBigDecimal​(String columnName,
                                    int scale)
                             throws SQLServerException

Deprecated.

Specified by:
  `getBigDecimal` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getBinaryStream

    public InputStream getBinaryStream​(int columnIndex)
                                throws SQLServerException

Specified by:
  `getBinaryStream` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getBinaryStream

    public InputStream getBinaryStream​(String columnName)
                                throws SQLServerException

Specified by:
  `getBinaryStream` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getBoolean

    public boolean getBoolean​(int columnIndex)
                       throws SQLServerException

Specified by:
  `getBoolean` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getBoolean

    public boolean getBoolean​(String columnName)
                       throws SQLServerException

Specified by:
  `getBoolean` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getByte

    public byte getByte​(int columnIndex)
                 throws SQLServerException

Specified by:
  `getByte` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getByte

    public byte getByte​(String columnName)
                 throws SQLServerException

Specified by:
  `getByte` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getBytes

    public byte[] getBytes​(int columnIndex)
                    throws SQLServerException

Specified by:
  `getBytes` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getBytes

    public byte[] getBytes​(String columnName)
                    throws SQLServerException

Specified by:
  `getBytes` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getDate

    public Date getDate​(int columnIndex)
                 throws SQLServerException

Specified by:
  `getDate` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getDate

    public Date getDate​(String columnName)
                 throws SQLServerException

Specified by:
  `getDate` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getDate

    public Date getDate​(int columnIndex,
                        Calendar cal)
                 throws SQLServerException

Specified by:
  `getDate` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getDate

    public Date getDate​(String colName,
                        Calendar cal)
                 throws SQLServerException

Specified by:
  `getDate` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getDouble

    public double getDouble​(int columnIndex)
                     throws SQLServerException

Specified by:
  `getDouble` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getDouble

    public double getDouble​(String columnName)
                     throws SQLServerException

Specified by:
  `getDouble` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getFloat

    public float getFloat​(int columnIndex)
                   throws SQLServerException

Specified by:
  `getFloat` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getFloat

    public float getFloat​(String columnName)
                   throws SQLServerException

Specified by:
  `getFloat` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getInt

    public int getInt​(int columnIndex)
               throws SQLServerException

Specified by:
  `getInt` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getInt

    public int getInt​(String columnName)
               throws SQLServerException

Specified by:
  `getInt` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getLong

    public long getLong​(int columnIndex)
                 throws SQLServerException

Specified by:
  `getLong` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getLong

    public long getLong​(String columnName)
                 throws SQLServerException

Specified by:
  `getLong` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getMetaData

    public ResultSetMetaData getMetaData​()
                                  throws SQLServerException

Specified by:
  `getMetaData` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getObject

    public Object getObject​(int columnIndex)
                     throws SQLServerException

Specified by:
  `getObject` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getObject

    public <T> T getObject​(int columnIndex,
                           Class<T> type)
                    throws SQLException

Specified by:
  `getObject` in interface `ResultSet`
Throws:
  `SQLException`

#### getObject

    public Object getObject​(String columnName)
                     throws SQLServerException

Specified by:
  `getObject` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getObject

    public <T> T getObject​(String columnName,
                           Class<T> type)
                    throws SQLException

Specified by:
  `getObject` in interface `ResultSet`
Throws:
  `SQLException`

#### getShort

    public short getShort​(int columnIndex)
                   throws SQLServerException

Specified by:
  `getShort` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getShort

    public short getShort​(String columnName)
                   throws SQLServerException

Specified by:
  `getShort` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getString

    public String getString​(int columnIndex)
                     throws SQLServerException

Specified by:
  `getString` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getString

    public String getString​(String columnName)
                     throws SQLServerException

Specified by:
  `getString` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getNString

    public String getNString​(int columnIndex)
                      throws SQLException

Specified by:
  `getNString` in interface `ResultSet`
Throws:
  `SQLException`

#### getNString

    public String getNString​(String columnLabel)
                      throws SQLException

Specified by:
  `getNString` in interface `ResultSet`
Throws:
  `SQLException`

#### getUniqueIdentifier

    public String getUniqueIdentifier​(int columnIndex)
                               throws SQLException

Retrieves the value of the designated column in the current row of this ResultSet object as a microsoft.sql.datetimeoffset object in the Java programming language.

Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
Returns:
  the column value; if the value is SQL NULL, the value returned is null
Throws:
  `SQLException` - when an error occurs

#### getUniqueIdentifier

    public String getUniqueIdentifier​(String columnLabel)
                               throws SQLException

Retrieves the value of the designated column in the current row of this ResultSet object as a microsoft.sql.datetimeoffset object in the Java programming language.

Parameters:
  `columnLabel` - the name of the column
Returns:
  the column value; if the value is SQL NULL, the value returned is null
Throws:
  `SQLException` - when an error occurs

#### getTime

    public Time getTime​(int columnIndex)
                 throws SQLServerException

Specified by:
  `getTime` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getTime

    public Time getTime​(String columnName)
                 throws SQLServerException

Specified by:
  `getTime` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getTime

    public Time getTime​(int columnIndex,
                        Calendar cal)
                 throws SQLServerException

Specified by:
  `getTime` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getTime

    public Time getTime​(String colName,
                        Calendar cal)
                 throws SQLServerException

Specified by:
  `getTime` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getTimestamp

    public Timestamp getTimestamp​(int columnIndex)
                           throws SQLServerException

Specified by:
  `getTimestamp` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getTimestamp

    public Timestamp getTimestamp​(String columnName)
                           throws SQLServerException

Specified by:
  `getTimestamp` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getTimestamp

    public Timestamp getTimestamp​(int columnIndex,
                                  Calendar cal)
                           throws SQLServerException

Specified by:
  `getTimestamp` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getTimestamp

    public Timestamp getTimestamp​(String colName,
                                  Calendar cal)
                           throws SQLServerException

Specified by:
  `getTimestamp` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getDateTime

    public Timestamp getDateTime​(int columnIndex)
                          throws SQLServerException

Retrieves the value of the designated column in the current row of this ResultSet object as a java.sql.Timestamp object in the Java programming language.

Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
Returns:
  the column value; if the value is SQL NULL, the value returned is null
Throws:
  `SQLServerException` - when an error occurs

#### getDateTime

    public Timestamp getDateTime​(String columnName)
                          throws SQLServerException

Retrieves the value of the designated column in the current row of this ResultSet object as a java.sql.Timestamp object in the Java programming language.

Parameters:
  `columnName` - is the name of the column
Returns:
  the column value; if the value is SQL NULL, the value returned is null
Throws:
  `SQLServerException` - If any errors occur.

#### getDateTime

    public Timestamp getDateTime​(int columnIndex,
                                 Calendar cal)
                          throws SQLServerException

Retrieves the value of the designated column in the current row of this ResultSet object as a java.sql.Timestamp object in the Java programming language. This method uses the given calendar to construct an appropriate millisecond value for the timestamp if the underlying database does not store timezone information.

Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `cal` - the java.util.Calendar object to use in constructing the dateTime
Returns:
  the column value; if the value is SQL NULL, the value returned is null
Throws:
  `SQLServerException` - If any errors occur.

#### getDateTime

    public Timestamp getDateTime​(String colName,
                                 Calendar cal)
                          throws SQLServerException

Retrieves the value of the designated column in the current row of this ResultSet object as a java.sql.Timestamp object in the Java programming language. This method uses the given calendar to construct an appropriate millisecond value for the timestamp if the underlying database does not store timezone information.

Parameters:
  `colName` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `cal` - the java.util.Calendar object to use in constructing the dateTime
Returns:
  the column value; if the value is SQL NULL, the value returned is null
Throws:
  `SQLServerException` - If any errors occur.

#### getSmallDateTime

    public Timestamp getSmallDateTime​(int columnIndex)
                               throws SQLServerException

Retrieves the value of the designated column in the current row of this ResultSet object as a java.sql.Timestamp object in the Java programming language.

Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
Returns:
  the column value; if the value is SQL NULL, the value returned is null
Throws:
  `SQLServerException` - when an error occurs

#### getSmallDateTime

    public Timestamp getSmallDateTime​(String columnName)
                               throws SQLServerException

Retrieves the value of the designated column in the current row of this ResultSet object as a java.sql.Timestamp object in the Java programming language.

Parameters:
  `columnName` - is the name of a column.
Returns:
  the column value; if the value is SQL NULL, the value returned is null
Throws:
  `SQLServerException` - If any errors occur.

#### getSmallDateTime

    public Timestamp getSmallDateTime​(int columnIndex,
                                      Calendar cal)
                               throws SQLServerException

Retrieves the value of the designated column in the current row of this ResultSet object as a java.sql.Timestamp object in the Java programming language.

Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `cal` - the java.util.Calendar object to use in constructing the smalldateTime
Returns:
  the column value; if the value is SQL NULL, the value returned is null
Throws:
  `SQLServerException` - If any errors occur.

#### getSmallDateTime

    public Timestamp getSmallDateTime​(String colName,
                                      Calendar cal)
                               throws SQLServerException

Parameters:
  `colName` - The name of a column
  `cal` - the java.util.Calendar object to use in constructing the smalldateTime
Returns:
  the column value; if the value is SQL NULL, the value returned is null
Throws:
  `SQLServerException` - If any errors occur.

#### getDateTimeOffset

    public DateTimeOffset getDateTimeOffset​(int columnIndex)
                                     throws SQLException

Description copied from interface: `ISQLServerResultSet`
Retrieves the value of the designated column as a microsoft.sql.DateTimeOffset object, given a zero-based column ordinal.

Specified by:
  `getDateTimeOffset` in interface `ISQLServerResultSet`
Parameters:
  `columnIndex` - The zero-based ordinal of a column.
Returns:
  A DateTimeOffset Class object.
Throws:
  `SQLException` - when an error occurs

#### getDateTimeOffset

    public DateTimeOffset getDateTimeOffset​(String columnName)
                                     throws SQLException

Description copied from interface: `ISQLServerResultSet`
Retrieves the value of the column specified as a microsoft.sql.DateTimeOffset object, given a column name.

Specified by:
  `getDateTimeOffset` in interface `ISQLServerResultSet`
Parameters:
  `columnName` - The name of a column.
Returns:
  A DateTimeOffset Class object.
Throws:
  `SQLException` - when an error occurs

#### getUnicodeStream

    @Deprecated
    public InputStream getUnicodeStream​(int columnIndex)
                                 throws SQLServerException

Deprecated.

Specified by:
  `getUnicodeStream` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getUnicodeStream

    @Deprecated
    public InputStream getUnicodeStream​(String columnName)
                                 throws SQLServerException

Deprecated.

Specified by:
  `getUnicodeStream` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getObject

    public Object getObject​(int i,
                            Map<String,Class<?>> map)
                     throws SQLServerException

Specified by:
  `getObject` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getRef

    public Ref getRef​(int i)
               throws SQLServerException

Specified by:
  `getRef` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getBlob

    public Blob getBlob​(int i)
                 throws SQLServerException

Specified by:
  `getBlob` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getBlob

    public Blob getBlob​(String colName)
                 throws SQLServerException

Specified by:
  `getBlob` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getClob

    public Clob getClob​(int columnIndex)
                 throws SQLServerException

Specified by:
  `getClob` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getClob

    public Clob getClob​(String colName)
                 throws SQLServerException

Specified by:
  `getClob` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getNClob

    public NClob getNClob​(int columnIndex)
                   throws SQLException

Specified by:
  `getNClob` in interface `ResultSet`
Throws:
  `SQLException`

#### getNClob

    public NClob getNClob​(String columnLabel)
                   throws SQLException

Specified by:
  `getNClob` in interface `ResultSet`
Throws:
  `SQLException`

#### getArray

    public Array getArray​(int i)
                   throws SQLServerException

Specified by:
  `getArray` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getObject

    public Object getObject​(String colName,
                            Map<String,Class<?>> map)
                     throws SQLServerException

Specified by:
  `getObject` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getRef

    public Ref getRef​(String colName)
               throws SQLServerException

Specified by:
  `getRef` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getArray

    public Array getArray​(String colName)
                   throws SQLServerException

Specified by:
  `getArray` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getCursorName

    public String getCursorName​()
                         throws SQLServerException

Specified by:
  `getCursorName` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getCharacterStream

    public Reader getCharacterStream​(int columnIndex)
                              throws SQLServerException

Specified by:
  `getCharacterStream` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getCharacterStream

    public Reader getCharacterStream​(String columnName)
                              throws SQLServerException

Specified by:
  `getCharacterStream` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getNCharacterStream

    public Reader getNCharacterStream​(int columnIndex)
                               throws SQLException

Specified by:
  `getNCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### getNCharacterStream

    public Reader getNCharacterStream​(String columnLabel)
                               throws SQLException

Specified by:
  `getNCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### getBigDecimal

    public BigDecimal getBigDecimal​(int columnIndex)
                             throws SQLServerException

Specified by:
  `getBigDecimal` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getBigDecimal

    public BigDecimal getBigDecimal​(String columnName)
                             throws SQLServerException

Specified by:
  `getBigDecimal` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getMoney

    public BigDecimal getMoney​(int columnIndex)
                        throws SQLServerException

Retrieves the value of the column specified as a java.math.BigDecimal object.

Parameters:
  `columnIndex` - The zero-based ordinal of a column.
Returns:
  the column value; if the value is SQL NULL, the value returned is null
Throws:
  `SQLServerException` - when an error occurs

#### getMoney

    public BigDecimal getMoney​(String columnName)
                        throws SQLServerException

Retrieves the value of the column specified as a java.math.BigDecimal object.

Parameters:
  `columnName` - is the name of a column.
Returns:
  the column value; if the value is SQL NULL, the value returned is null.
Throws:
  `SQLServerException` - If any errors occur.

#### getSmallMoney

    public BigDecimal getSmallMoney​(int columnIndex)
                             throws SQLServerException

Retrieves the value of the column specified as a java.math.BigDecimal object.

Parameters:
  `columnIndex` - The zero-based ordinal of a column.
Returns:
  the column value; if the value is SQL NULL, the value returned is null
Throws:
  `SQLServerException` - If any errors occur.

#### getSmallMoney

    public BigDecimal getSmallMoney​(String columnName)
                             throws SQLServerException

Retrieves the value of the column specified as a java.math.BigDecimal object.

Parameters:
  `columnName` - is the name of a column.
Returns:
  the column value; if the value is SQL NULL, the value returned is null.
Throws:
  `SQLServerException` - If any errors occur.

#### getRowId

    public RowId getRowId​(int columnIndex)
                   throws SQLException

Specified by:
  `getRowId` in interface `ResultSet`
Throws:
  `SQLException`

#### getRowId

    public RowId getRowId​(String columnLabel)
                   throws SQLException

Specified by:
  `getRowId` in interface `ResultSet`
Throws:
  `SQLException`

#### getSQLXML

    public SQLXML getSQLXML​(int columnIndex)
                     throws SQLException

Specified by:
  `getSQLXML` in interface `ResultSet`
Throws:
  `SQLException`

#### getSQLXML

    public SQLXML getSQLXML​(String columnLabel)
                     throws SQLException

Specified by:
  `getSQLXML` in interface `ResultSet`
Throws:
  `SQLException`

#### rowUpdated

    public boolean rowUpdated​()
                       throws SQLServerException

Specified by:
  `rowUpdated` in interface `ResultSet`
Throws:
  `SQLServerException`

#### rowInserted

    public boolean rowInserted​()
                        throws SQLServerException

Specified by:
  `rowInserted` in interface `ResultSet`
Throws:
  `SQLServerException`

#### rowDeleted

    public boolean rowDeleted​()
                       throws SQLServerException

Specified by:
  `rowDeleted` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateNull

    public void updateNull​(int index)
                    throws SQLServerException

Specified by:
  `updateNull` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateBoolean

    public void updateBoolean​(int index,
                              boolean x)
                       throws SQLServerException

Specified by:
  `updateBoolean` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateBoolean

    public void updateBoolean​(int index,
                              boolean x,
                              boolean forceEncrypt)
                       throws SQLServerException

Updates the designated column with a `boolean` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - when an error occurs

#### updateByte

    public void updateByte​(int index,
                           byte x)
                    throws SQLServerException

Specified by:
  `updateByte` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateByte

    public void updateByte​(int index,
                           byte x,
                           boolean forceEncrypt)
                    throws SQLServerException

Updates the designated column with a `byte` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - when an error occurs

#### updateShort

    public void updateShort​(int index,
                            short x)
                     throws SQLServerException

Specified by:
  `updateShort` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateShort

    public void updateShort​(int index,
                            short x,
                            boolean forceEncrypt)
                     throws SQLServerException

Updates the designated column with a `short` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - when an error occurs

#### updateInt

    public void updateInt​(int index,
                          int x)
                   throws SQLServerException

Specified by:
  `updateInt` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateInt

    public void updateInt​(int index,
                          int x,
                          boolean forceEncrypt)
                   throws SQLServerException

Updates the designated column with an `int` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - when an error occurs

#### updateLong

    public void updateLong​(int index,
                           long x)
                    throws SQLServerException

Specified by:
  `updateLong` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateLong

    public void updateLong​(int index,
                           long x,
                           boolean forceEncrypt)
                    throws SQLServerException

Updates the designated column with a `long` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - when an error occurs

#### updateFloat

    public void updateFloat​(int index,
                            float x)
                     throws SQLServerException

Specified by:
  `updateFloat` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateFloat

    public void updateFloat​(int index,
                            float x,
                            boolean forceEncrypt)
                     throws SQLServerException

Updates the designated column with a `float` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - when an error occurs

#### updateDouble

    public void updateDouble​(int index,
                             double x)
                      throws SQLServerException

Specified by:
  `updateDouble` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateDouble

    public void updateDouble​(int index,
                             double x,
                             boolean forceEncrypt)
                      throws SQLServerException

Updates the designated column with a `double` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - when an error occurs

#### updateMoney

    public void updateMoney​(int index,
                            BigDecimal x)
                     throws SQLServerException

Updates the designated column with a `money` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLServerException` - when an error occurs

#### updateMoney

    public void updateMoney​(int index,
                            BigDecimal x,
                            boolean forceEncrypt)
                     throws SQLServerException

Updates the designated column with a `money` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - when an error occurs

#### updateMoney

    public void updateMoney​(String columnName,
                            BigDecimal x)
                     throws SQLServerException

Updates the designated column with a `money` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - is the column name
  `x` - the new column value
Throws:
  `SQLServerException` - If any errors occur.

#### updateMoney

    public void updateMoney​(String columnName,
                            BigDecimal x,
                            boolean forceEncrypt)
                     throws SQLServerException

Updates the designated column with a `money` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - the column name
  `x` - the new column value
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - If any errors occur.

#### updateSmallMoney

    public void updateSmallMoney​(int index,
                                 BigDecimal x)
                          throws SQLServerException

Updates the designated column with a `smallmoney` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLServerException` - when an error occurs

#### updateSmallMoney

    public void updateSmallMoney​(int index,
                                 BigDecimal x,
                                 boolean forceEncrypt)
                          throws SQLServerException

Updates the designated column with a `smallmoney` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - when an error occurs

#### updateSmallMoney

    public void updateSmallMoney​(String columnName,
                                 BigDecimal x)
                          throws SQLServerException

Updates the designated column with a `smallmoney` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - the column name
  `x` - the new column value
Throws:
  `SQLServerException` - If any errors occur.

#### updateSmallMoney

    public void updateSmallMoney​(String columnName,
                                 BigDecimal x,
                                 boolean forceEncrypt)
                          throws SQLServerException

Updates the designated column with a `smallmoney` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - the column name
  `x` - the new column value
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - If any errors occur.

#### updateBigDecimal

    public void updateBigDecimal​(int index,
                                 BigDecimal x)
                          throws SQLServerException

Specified by:
  `updateBigDecimal` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateBigDecimal

    public void updateBigDecimal​(int index,
                                 BigDecimal x,
                                 Integer precision,
                                 Integer scale)
                          throws SQLServerException

Updates the designated column with a `java.math.BigDecimal` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `precision` - the precision of the column
  `scale` - the scale of the column
Throws:
  `SQLServerException` - when an error occurs

#### updateBigDecimal

    public void updateBigDecimal​(int index,
                                 BigDecimal x,
                                 Integer precision,
                                 Integer scale,
                                 boolean forceEncrypt)
                          throws SQLServerException

Updates the designated column with a `java.math.BigDecimal` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `precision` - the precision of the column
  `scale` - the scale of the column
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - when an error occurs

#### updateString

    public void updateString​(int columnIndex,
                             String stringValue)
                      throws SQLServerException

Specified by:
  `updateString` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateString

    public void updateString​(int columnIndex,
                             String stringValue,
                             boolean forceEncrypt)
                      throws SQLServerException

Updates the designated column with a `String` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `stringValue` - the new column value
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - when an error occurs

#### updateNString

    public void updateNString​(int columnIndex,
                              String nString)
                       throws SQLException

Specified by:
  `updateNString` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNString

    public void updateNString​(int columnIndex,
                              String nString,
                              boolean forceEncrypt)
                       throws SQLException

Updates the designated column with a `String` value. It is intended for use when updating `NCHAR`,`NVARCHAR` and `LONGNVARCHAR` columns. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnIndex` - the first column is 1, the second 2, ...
  `nString` - the value for the column to be updated
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLException` - when an error occurs

#### updateNString

    public void updateNString​(String columnLabel,
                              String nString)
                       throws SQLException

Specified by:
  `updateNString` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNString

    public void updateNString​(String columnLabel,
                              String nString,
                              boolean forceEncrypt)
                       throws SQLException

Updates the designated column with a `String` value. It is intended for use when updating `NCHAR`,`NVARCHAR` and `LONGNVARCHAR` columns. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `nString` - the value for the column to be updated
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLException` - when an error occurs

#### updateBytes

    public void updateBytes​(int index,
                            byte[] x)
                     throws SQLServerException

Specified by:
  `updateBytes` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateBytes

    public void updateBytes​(int index,
                            byte[] x,
                            boolean forceEncrypt)
                     throws SQLServerException

Updates the designated column with a `byte` array value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - when an error occurs

#### updateDate

    public void updateDate​(int index,
                           Date x)
                    throws SQLServerException

Specified by:
  `updateDate` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateDate

    public void updateDate​(int index,
                           Date x,
                           boolean forceEncrypt)
                    throws SQLServerException

Updates the designated column with a `java.sql.Date` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - when an error occurs

#### updateTime

    public void updateTime​(int index,
                           Time x)
                    throws SQLServerException

Specified by:
  `updateTime` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateTime

    public void updateTime​(int index,
                           Time x,
                           Integer scale)
                    throws SQLServerException

Updates the designated column with a `java.sql.Time` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `scale` - the scale of the column
Throws:
  `SQLServerException` - when an error occurs

#### updateTime

    public void updateTime​(int index,
                           Time x,
                           Integer scale,
                           boolean forceEncrypt)
                    throws SQLServerException

Updates the designated column with a `java.sql.Time` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `scale` - the scale of the column
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - when an error occurs

#### updateTimestamp

    public void updateTimestamp​(int index,
                                Timestamp x)
                         throws SQLServerException

Specified by:
  `updateTimestamp` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateTimestamp

    public void updateTimestamp​(int index,
                                Timestamp x,
                                int scale)
                         throws SQLServerException

Updates the designated column with a `java.sql.Timestamp` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `scale` - the scale of the column
Throws:
  `SQLServerException` - when an error occurs

#### updateTimestamp

    public void updateTimestamp​(int index,
                                Timestamp x,
                                int scale,
                                boolean forceEncrypt)
                         throws SQLServerException

Updates the designated column with a `java.sql.Timestamp` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `scale` - the scale of the column
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - when an error occurs

#### updateDateTime

    public void updateDateTime​(int index,
                               Timestamp x)
                        throws SQLServerException

Updates the designated column with a `java.sql.Timestamp` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLServerException` - when an error occurs

#### updateDateTime

    public void updateDateTime​(int index,
                               Timestamp x,
                               Integer scale)
                        throws SQLServerException

Updates the designated column with a `java.sql.Timestamp` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `scale` - the scale of the column
Throws:
  `SQLServerException` - when an error occurs

#### updateDateTime

    public void updateDateTime​(int index,
                               Timestamp x,
                               Integer scale,
                               boolean forceEncrypt)
                        throws SQLServerException

Updates the designated column with a `java.sql.Timestamp` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `scale` - the scale of the column
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - when an error occurs

#### updateSmallDateTime

    public void updateSmallDateTime​(int index,
                                    Timestamp x)
                             throws SQLServerException

Updates the designated column with a `java.sql.Timestamp` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLServerException` - when an error occurs

#### updateSmallDateTime

    public void updateSmallDateTime​(int index,
                                    Timestamp x,
                                    Integer scale)
                             throws SQLServerException

Updates the designated column with a `java.sql.Timestamp` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `scale` - the scale of the column
Throws:
  `SQLServerException` - when an error occurs

#### updateSmallDateTime

    public void updateSmallDateTime​(int index,
                                    Timestamp x,
                                    Integer scale,
                                    boolean forceEncrypt)
                             throws SQLServerException

Updates the designated column with a `java.sql.Timestamp` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `scale` - the scale of the column
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - when an error occurs

#### updateDateTimeOffset

    public void updateDateTimeOffset​(int index,
                                     DateTimeOffset x)
                              throws SQLException

Description copied from interface: `ISQLServerResultSet`
Updates the value of the column specified to the DateTimeOffset Class value, given a zero-based column ordinal.

Specified by:
  `updateDateTimeOffset` in interface `ISQLServerResultSet`
Parameters:
  `index` - The zero-based ordinal of a column.
  `x` - A DateTimeOffset Class object.
Throws:
  `SQLException` - when an error occurs

#### updateDateTimeOffset

    public void updateDateTimeOffset​(int index,
                                     DateTimeOffset x,
                                     Integer scale)
                              throws SQLException

Updates the value of the column specified to the DateTimeOffset Class value, given a zero-based column ordinal.

Parameters:
  `index` - The zero-based ordinal of a column.
  `x` - A DateTimeOffset Class object.
  `scale` - scale of the column
Throws:
  `SQLException` - when an error occurs

#### updateDateTimeOffset

    public void updateDateTimeOffset​(int index,
                                     DateTimeOffset x,
                                     Integer scale,
                                     boolean forceEncrypt)
                              throws SQLException

Updates the value of the column specified to the DateTimeOffset Class value, given a zero-based column ordinal.

Parameters:
  `index` - The zero-based ordinal of a column.
  `x` - A DateTimeOffset Class object.
  `scale` - scale of the column
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLException` - when an error occurs

#### updateUniqueIdentifier

    public void updateUniqueIdentifier​(int index,
                                       String x)
                                throws SQLException

Updates the designated column with a `String` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - The zero-based ordinal of a column.
  `x` - the new column value
Throws:
  `SQLException` - when an error occurs

#### updateUniqueIdentifier

    public void updateUniqueIdentifier​(int index,
                                       String x,
                                       boolean forceEncrypt)
                                throws SQLException

Updates the designated column with a `String` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - The zero-based ordinal of a column.
  `x` - the new column value
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLException` - when an error occurs

#### updateAsciiStream

    public void updateAsciiStream​(int columnIndex,
                                  InputStream x)
                           throws SQLException

Specified by:
  `updateAsciiStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateAsciiStream

    public void updateAsciiStream​(int index,
                                  InputStream x,
                                  int length)
                           throws SQLServerException

Specified by:
  `updateAsciiStream` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateAsciiStream

    public void updateAsciiStream​(int columnIndex,
                                  InputStream x,
                                  long length)
                           throws SQLException

Specified by:
  `updateAsciiStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateAsciiStream

    public void updateAsciiStream​(String columnLabel,
                                  InputStream x)
                           throws SQLException

Specified by:
  `updateAsciiStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateAsciiStream

    public void updateAsciiStream​(String columnName,
                                  InputStream x,
                                  int length)
                           throws SQLServerException

Specified by:
  `updateAsciiStream` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateAsciiStream

    public void updateAsciiStream​(String columnName,
                                  InputStream streamValue,
                                  long length)
                           throws SQLException

Specified by:
  `updateAsciiStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBinaryStream

    public void updateBinaryStream​(int columnIndex,
                                   InputStream x)
                            throws SQLException

Specified by:
  `updateBinaryStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBinaryStream

    public void updateBinaryStream​(int columnIndex,
                                   InputStream streamValue,
                                   int length)
                            throws SQLException

Specified by:
  `updateBinaryStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBinaryStream

    public void updateBinaryStream​(int columnIndex,
                                   InputStream x,
                                   long length)
                            throws SQLException

Specified by:
  `updateBinaryStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBinaryStream

    public void updateBinaryStream​(String columnLabel,
                                   InputStream x)
                            throws SQLException

Specified by:
  `updateBinaryStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBinaryStream

    public void updateBinaryStream​(String columnName,
                                   InputStream streamValue,
                                   int length)
                            throws SQLException

Specified by:
  `updateBinaryStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBinaryStream

    public void updateBinaryStream​(String columnLabel,
                                   InputStream x,
                                   long length)
                            throws SQLException

Specified by:
  `updateBinaryStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateCharacterStream

    public void updateCharacterStream​(int columnIndex,
                                      Reader x)
                               throws SQLException

Specified by:
  `updateCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateCharacterStream

    public void updateCharacterStream​(int columnIndex,
                                      Reader readerValue,
                                      int length)
                               throws SQLServerException

Specified by:
  `updateCharacterStream` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateCharacterStream

    public void updateCharacterStream​(int columnIndex,
                                      Reader x,
                                      long length)
                               throws SQLException

Specified by:
  `updateCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateCharacterStream

    public void updateCharacterStream​(String columnLabel,
                                      Reader reader)
                               throws SQLException

Specified by:
  `updateCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateCharacterStream

    public void updateCharacterStream​(String columnName,
                                      Reader readerValue,
                                      int length)
                               throws SQLServerException

Specified by:
  `updateCharacterStream` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateCharacterStream

    public void updateCharacterStream​(String columnLabel,
                                      Reader reader,
                                      long length)
                               throws SQLException

Specified by:
  `updateCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNCharacterStream

    public void updateNCharacterStream​(int columnIndex,
                                       Reader x)
                                throws SQLException

Specified by:
  `updateNCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNCharacterStream

    public void updateNCharacterStream​(int columnIndex,
                                       Reader x,
                                       long length)
                                throws SQLException

Specified by:
  `updateNCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNCharacterStream

    public void updateNCharacterStream​(String columnLabel,
                                       Reader reader)
                                throws SQLException

Specified by:
  `updateNCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNCharacterStream

    public void updateNCharacterStream​(String columnLabel,
                                       Reader reader,
                                       long length)
                                throws SQLException

Specified by:
  `updateNCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateObject

    public void updateObject​(int index,
                             Object obj)
                      throws SQLServerException

Specified by:
  `updateObject` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateObject

    public void updateObject​(int index,
                             Object x,
                             int scale)
                      throws SQLServerException

Specified by:
  `updateObject` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateObject

    public void updateObject​(int index,
                             Object x,
                             int precision,
                             int scale)
                      throws SQLServerException

Updates the designated column with an `Object` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `precision` - the precision of the column
  `scale` - the scale of the column
Throws:
  `SQLServerException` - when an error occurs

#### updateObject

    public void updateObject​(int index,
                             Object x,
                             int precision,
                             int scale,
                             boolean forceEncrypt)
                      throws SQLServerException

Updates the designated column with an `Object` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `index` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `precision` - the precision of the column
  `scale` - the scale of the column
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - when an error occurs

#### updateObject

    protected final void updateObject​(int index,
                                      Object x,
                                      Integer scale,
                                      com.microsoft.sqlserver.jdbc.JDBCType jdbcType,
                                      Integer precision,
                                      boolean forceEncrypt)
                               throws SQLServerException

Throws:
  `SQLServerException`

#### updateNull

    public void updateNull​(String columnName)
                    throws SQLServerException

Specified by:
  `updateNull` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateBoolean

    public void updateBoolean​(String columnName,
                              boolean x)
                       throws SQLServerException

Specified by:
  `updateBoolean` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateBoolean

    public void updateBoolean​(String columnName,
                              boolean x,
                              boolean forceEncrypt)
                       throws SQLServerException

Updates the designated column with a `boolean` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - the name of the column
  `x` - the new column value
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - when an error occurs

#### updateByte

    public void updateByte​(String columnName,
                           byte x)
                    throws SQLServerException

Specified by:
  `updateByte` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateByte

    public void updateByte​(String columnName,
                           byte x,
                           boolean forceEncrypt)
                    throws SQLServerException

Updates the designated column with a `byte` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - the name of the column
  `x` - the new column value
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - If any errors occur.

#### updateShort

    public void updateShort​(String columnName,
                            short x)
                     throws SQLServerException

Specified by:
  `updateShort` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateShort

    public void updateShort​(String columnName,
                            short x,
                            boolean forceEncrypt)
                     throws SQLServerException

Updates the designated column with a `short` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - the name of the column
  `x` - the new column value
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - If any errors occur.

#### updateInt

    public void updateInt​(String columnName,
                          int x)
                   throws SQLServerException

Specified by:
  `updateInt` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateInt

    public void updateInt​(String columnName,
                          int x,
                          boolean forceEncrypt)
                   throws SQLServerException

Updates the designated column with an `int` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - is the name of the column
  `x` - the new column value
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - If any errors occur.

#### updateLong

    public void updateLong​(String columnName,
                           long x)
                    throws SQLServerException

Specified by:
  `updateLong` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateLong

    public void updateLong​(String columnName,
                           long x,
                           boolean forceEncrypt)
                    throws SQLServerException

Updates the designated column with a `long` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - is the name of the column
  `x` - the new column value
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - If any errors occur.

#### updateFloat

    public void updateFloat​(String columnName,
                            float x)
                     throws SQLServerException

Specified by:
  `updateFloat` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateFloat

    public void updateFloat​(String columnName,
                            float x,
                            boolean forceEncrypt)
                     throws SQLServerException

Updates the designated column with a `float` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - is the name of the column
  `x` - the new column value
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - If any errors occur.

#### updateDouble

    public void updateDouble​(String columnName,
                             double x)
                      throws SQLServerException

Specified by:
  `updateDouble` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateDouble

    public void updateDouble​(String columnName,
                             double x,
                             boolean forceEncrypt)
                      throws SQLServerException

Updates the designated column with a `double` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - is the name of the column
  `x` - the new column value
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - If any errors occur.

#### updateBigDecimal

    public void updateBigDecimal​(String columnName,
                                 BigDecimal x)
                          throws SQLServerException

Specified by:
  `updateBigDecimal` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateBigDecimal

    public void updateBigDecimal​(String columnName,
                                 BigDecimal x,
                                 boolean forceEncrypt)
                          throws SQLServerException

Updates the designated column with a `java.sql.BigDecimal` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - is the name of the column
  `x` - the new column value
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - If any errors occur.

#### updateBigDecimal

    public void updateBigDecimal​(String columnName,
                                 BigDecimal x,
                                 Integer precision,
                                 Integer scale)
                          throws SQLServerException

Updates the designated column with a `java.sql.BigDecimal` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - is the name of the column and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
  `x` - BigDecimal value
  `precision` - the precision of the column
  `scale` - the scale of the column
Throws:
  `SQLServerException` - If any errors occur.

#### updateBigDecimal

    public void updateBigDecimal​(String columnName,
                                 BigDecimal x,
                                 Integer precision,
                                 Integer scale,
                                 boolean forceEncrypt)
                          throws SQLServerException

Updates the designated column with a `java.sql.BigDecimal` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - is the name of the column and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
  `x` - BigDecimal value
  `precision` - the precision of the column
  `scale` - the scale of the column
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - If any errors occur.

#### updateString

    public void updateString​(String columnName,
                             String x)
                      throws SQLServerException

Specified by:
  `updateString` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateString

    public void updateString​(String columnName,
                             String x,
                             boolean forceEncrypt)
                      throws SQLServerException

Updates the designated column with a `String` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - is the name of the column
  `x` - the new column value
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - If any errors occur.

#### updateBytes

    public void updateBytes​(String columnName,
                            byte[] x)
                     throws SQLServerException

Specified by:
  `updateBytes` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateBytes

    public void updateBytes​(String columnName,
                            byte[] x,
                            boolean forceEncrypt)
                     throws SQLServerException

Updates the designated column with a byte array value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - is the name of the column
  `x` - the new column value
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - If any errors occur.

#### updateDate

    public void updateDate​(String columnName,
                           Date x)
                    throws SQLServerException

Specified by:
  `updateDate` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateDate

    public void updateDate​(String columnName,
                           Date x,
                           boolean forceEncrypt)
                    throws SQLServerException

Updates the designated column with a `java.sql.Date` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - is the name of the column
  `x` - the new column value
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - If any errors occur.

#### updateTime

    public void updateTime​(String columnName,
                           Time x)
                    throws SQLServerException

Specified by:
  `updateTime` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateTime

    public void updateTime​(String columnName,
                           Time x,
                           int scale)
                    throws SQLServerException

Updates the designated column with a `java.sql.Time` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - is the name of the column
  `x` - the new column value
  `scale` - the scale of the column
Throws:
  `SQLServerException` - If any errors occur.

#### updateTime

    public void updateTime​(String columnName,
                           Time x,
                           int scale,
                           boolean forceEncrypt)
                    throws SQLServerException

Updates the designated column with a `java.sql.Time` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - is the name of the column
  `x` - the new column value
  `scale` - the scale of the column
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - If any errors occur.

#### updateTimestamp

    public void updateTimestamp​(String columnName,
                                Timestamp x)
                         throws SQLServerException

Specified by:
  `updateTimestamp` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateTimestamp

    public void updateTimestamp​(String columnName,
                                Timestamp x,
                                int scale)
                         throws SQLServerException

Updates the designated column with a `java.sql.Timestamp` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - is the name of the column
  `x` - the new column value
  `scale` - the scale of the column
Throws:
  `SQLServerException` - If any errors occur.

#### updateTimestamp

    public void updateTimestamp​(String columnName,
                                Timestamp x,
                                int scale,
                                boolean forceEncrypt)
                         throws SQLServerException

Updates the designated column with a `java.sql.Timestamp` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - is the name of the column
  `x` - the new column value
  `scale` - the scale of the column
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - If any errors occur.

#### updateDateTime

    public void updateDateTime​(String columnName,
                               Timestamp x)
                        throws SQLServerException

Updates the designated column with a `java.sql.Timestamp` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - is the name of the column
  `x` - the new column value
Throws:
  `SQLServerException` - If any errors occur.

#### updateDateTime

    public void updateDateTime​(String columnName,
                               Timestamp x,
                               int scale)
                        throws SQLServerException

Updates the designated column with a `java.sql.Timestamp` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - is the name of the column
  `x` - the new column value
  `scale` - the scale of the column
Throws:
  `SQLServerException` - If any errors occur.

#### updateDateTime

    public void updateDateTime​(String columnName,
                               Timestamp x,
                               int scale,
                               boolean forceEncrypt)
                        throws SQLServerException

Updates the designated column with a `java.sql.Timestamp` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - is the name of the column
  `x` - the new column value
  `scale` - the scale of the column
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - If any errors occur.

#### updateSmallDateTime

    public void updateSmallDateTime​(String columnName,
                                    Timestamp x)
                             throws SQLServerException

Updates the designated column with a `java.sql.Timestamp` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - is the name of the column
  `x` - the new column value
Throws:
  `SQLServerException` - If any errors occur.

#### updateSmallDateTime

    public void updateSmallDateTime​(String columnName,
                                    Timestamp x,
                                    int scale)
                             throws SQLServerException

Updates the designated column with a `java.sql.Timestamp` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - is the name of the column
  `x` - the new column value
  `scale` - the scale of the column
Throws:
  `SQLServerException` - If any errors occur.

#### updateSmallDateTime

    public void updateSmallDateTime​(String columnName,
                                    Timestamp x,
                                    int scale,
                                    boolean forceEncrypt)
                             throws SQLServerException

Updates the designated column with a `java.sql.Timestamp` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - is the name of the column
  `x` - the new column value
  `scale` - the scale of the column
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - If any errors occur.

#### updateDateTimeOffset

    public void updateDateTimeOffset​(String columnName,
                                     DateTimeOffset x)
                              throws SQLException

Description copied from interface: `ISQLServerResultSet`
Updates the value of the column specified to the DateTimeOffset Class value, given a column name.

Specified by:
  `updateDateTimeOffset` in interface `ISQLServerResultSet`
Parameters:
  `columnName` - The name of a column.
  `x` - A DateTimeOffset Class object.
Throws:
  `SQLException` - when an error occurs

#### updateDateTimeOffset

    public void updateDateTimeOffset​(String columnName,
                                     DateTimeOffset x,
                                     int scale)
                              throws SQLException

Updates the value of the column specified to the DateTimeOffset Class value, given a column name.

Parameters:
  `columnName` - The name of a column.
  `x` - A DateTimeOffset Class object.
  `scale` - the scale of the column
Throws:
  `SQLServerException` - If any errors occur.
  `SQLException`

#### updateDateTimeOffset

    public void updateDateTimeOffset​(String columnName,
                                     DateTimeOffset x,
                                     int scale,
                                     boolean forceEncrypt)
                              throws SQLException

Updates the value of the column specified to the DateTimeOffset Class value, given a column name.

Parameters:
  `columnName` - The name of a column.
  `x` - A DateTimeOffset Class object.
  `scale` - the scale of the column
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLException` - If any errors occur.

#### updateUniqueIdentifier

    public void updateUniqueIdentifier​(String columnName,
                                       String x)
                                throws SQLException

Updates the designated column with a `String`value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - The name of a column.
  `x` - the new column value
Throws:
  `SQLException` - If any errors occur.

#### updateUniqueIdentifier

    public void updateUniqueIdentifier​(String columnName,
                                       String x,
                                       boolean forceEncrypt)
                                throws SQLException

Updates the designated column with a `String`value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - The name of a column.
  `x` - the new column value
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLException` - If any errors occur.

#### updateObject

    public void updateObject​(String columnName,
                             Object x,
                             int scale)
                      throws SQLServerException

Specified by:
  `updateObject` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateObject

    public void updateObject​(String columnName,
                             Object x,
                             int precision,
                             int scale)
                      throws SQLServerException

Updates the designated column with an `Object` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - The name of a column.
  `x` - the new column value
  `precision` - the precision of the column
  `scale` - the scale of the column
Throws:
  `SQLServerException` - If any errors occur.

#### updateObject

    public void updateObject​(String columnName,
                             Object x,
                             int precision,
                             int scale,
                             boolean forceEncrypt)
                      throws SQLServerException

Updates the designated column with an `Object` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Parameters:
  `columnName` - The name of a column.
  `x` - the new column value
  `precision` - the precision of the column
  `scale` - the scale of the column
  `forceEncrypt` - If the boolean forceEncrypt is set to true, the query parameter will only be set if the designation column is encrypted and Always Encrypted is enabled on the connection or on the statement. If the boolean forceEncrypt is set to false, the driver will not force encryption on parameters.
Throws:
  `SQLServerException` - If any errors occur.

#### updateObject

    public void updateObject​(String columnName,
                             Object x)
                      throws SQLServerException

Specified by:
  `updateObject` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateRowId

    public void updateRowId​(int columnIndex,
                            RowId x)
                     throws SQLException

Specified by:
  `updateRowId` in interface `ResultSet`
Throws:
  `SQLException`

#### updateRowId

    public void updateRowId​(String columnLabel,
                            RowId x)
                     throws SQLException

Specified by:
  `updateRowId` in interface `ResultSet`
Throws:
  `SQLException`

#### updateSQLXML

    public void updateSQLXML​(int columnIndex,
                             SQLXML xmlObject)
                      throws SQLException

Specified by:
  `updateSQLXML` in interface `ResultSet`
Throws:
  `SQLException`

#### updateSQLXML

    public void updateSQLXML​(String columnLabel,
                             SQLXML x)
                      throws SQLException

Specified by:
  `updateSQLXML` in interface `ResultSet`
Throws:
  `SQLException`

#### getHoldability

    public int getHoldability​()
                       throws SQLException

Specified by:
  `getHoldability` in interface `ResultSet`
Throws:
  `SQLException`

#### insertRow

    public void insertRow​()
                   throws SQLServerException

Specified by:
  `insertRow` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateRow

    public void updateRow​()
                   throws SQLServerException

Specified by:
  `updateRow` in interface `ResultSet`
Throws:
  `SQLServerException`

#### deleteRow

    public void deleteRow​()
                   throws SQLServerException

Specified by:
  `deleteRow` in interface `ResultSet`
Throws:
  `SQLServerException`

#### refreshRow

    public void refreshRow​()
                    throws SQLServerException

Specified by:
  `refreshRow` in interface `ResultSet`
Throws:
  `SQLServerException`

#### cancelRowUpdates

    public void cancelRowUpdates​()
                          throws SQLServerException

Specified by:
  `cancelRowUpdates` in interface `ResultSet`
Throws:
  `SQLServerException`

#### moveToInsertRow

    public void moveToInsertRow​()
                         throws SQLServerException

Specified by:
  `moveToInsertRow` in interface `ResultSet`
Throws:
  `SQLServerException`

#### moveToCurrentRow

    public void moveToCurrentRow​()
                          throws SQLServerException

Specified by:
  `moveToCurrentRow` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getStatement

    public Statement getStatement​()
                           throws SQLServerException

Specified by:
  `getStatement` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateClob

    public void updateClob​(int columnIndex,
                           Clob clobValue)
                    throws SQLException

Specified by:
  `updateClob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateClob

    public void updateClob​(int columnIndex,
                           Reader reader)
                    throws SQLException

Specified by:
  `updateClob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateClob

    public void updateClob​(int columnIndex,
                           Reader reader,
                           long length)
                    throws SQLException

Specified by:
  `updateClob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateClob

    public void updateClob​(String columnName,
                           Clob clobValue)
                    throws SQLException

Specified by:
  `updateClob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateClob

    public void updateClob​(String columnLabel,
                           Reader reader)
                    throws SQLException

Specified by:
  `updateClob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateClob

    public void updateClob​(String columnLabel,
                           Reader reader,
                           long length)
                    throws SQLException

Specified by:
  `updateClob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNClob

    public void updateNClob​(int columnIndex,
                            NClob nClob)
                     throws SQLException

Specified by:
  `updateNClob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNClob

    public void updateNClob​(int columnIndex,
                            Reader reader)
                     throws SQLException

Specified by:
  `updateNClob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNClob

    public void updateNClob​(int columnIndex,
                            Reader reader,
                            long length)
                     throws SQLException

Specified by:
  `updateNClob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNClob

    public void updateNClob​(String columnLabel,
                            NClob nClob)
                     throws SQLException

Specified by:
  `updateNClob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNClob

    public void updateNClob​(String columnLabel,
                            Reader reader)
                     throws SQLException

Specified by:
  `updateNClob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNClob

    public void updateNClob​(String columnLabel,
                            Reader reader,
                            long length)
                     throws SQLException

Specified by:
  `updateNClob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBlob

    public void updateBlob​(int columnIndex,
                           Blob blobValue)
                    throws SQLException

Specified by:
  `updateBlob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBlob

    public void updateBlob​(int columnIndex,
                           InputStream inputStream)
                    throws SQLException

Specified by:
  `updateBlob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBlob

    public void updateBlob​(int columnIndex,
                           InputStream inputStream,
                           long length)
                    throws SQLException

Specified by:
  `updateBlob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBlob

    public void updateBlob​(String columnName,
                           Blob blobValue)
                    throws SQLException

Specified by:
  `updateBlob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBlob

    public void updateBlob​(String columnLabel,
                           InputStream inputStream)
                    throws SQLException

Specified by:
  `updateBlob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBlob

    public void updateBlob​(String columnLabel,
                           InputStream inputStream,
                           long length)
                    throws SQLException

Specified by:
  `updateBlob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateArray

    public void updateArray​(int columnIndex,
                            Array x)
                     throws SQLServerException

Specified by:
  `updateArray` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateArray

    public void updateArray​(String columnName,
                            Array x)
                     throws SQLServerException

Specified by:
  `updateArray` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateRef

    public void updateRef​(int columnIndex,
                          Ref x)
                   throws SQLServerException

Specified by:
  `updateRef` in interface `ResultSet`
Throws:
  `SQLServerException`

#### updateRef

    public void updateRef​(String columnName,
                          Ref x)
                   throws SQLServerException

Specified by:
  `updateRef` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getURL

    public URL getURL​(int columnIndex)
               throws SQLServerException

Specified by:
  `getURL` in interface `ResultSet`
Throws:
  `SQLServerException`

#### getURL

    public URL getURL​(String sColumn)
               throws SQLServerException

Specified by:
  `getURL` in interface `ResultSet`
Throws:
  `SQLServerException`